VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.ISettings
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, cbName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpKeyName As String) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function ExpandEnvironmentStrings Lib "advapi32.dll" (lpSrc As String, lpDst As String, ByVal nSize As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Variant
    bInheritHandle As Long
End Type

Public Enum HKeys
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

Public Enum lDataType
    REG_NONE = 0
    REG_SZ = 1
    REG_EXPAND_SZ = 2
    REG_BINARY = 3
    REG_DWORD = 4
    REG_DWORD_LITTLE_ENDIAN = 4
    REG_DWORD_BIG_ENDIAN = 5
    REG_LINK = 6
    REG_MULTI_SZ = 7
    REG_RESOURCE_LIST = 8
    REG_FULL_RESOURCE_DESCRIPTOR = 9
    REG_RESOURCE_REQUIREMENTS_LIST = 10
End Enum

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000
Private Const KEY_READ = &H20009
Private Const KEY_WRITE = &H20006
Private Const KEY_READ_WRITE = (KEY_READ Or KEY_WRITE)
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Private Const REG_OPTION_NON_VOLATILE = 0&
Private Const REG_OPTION_VOLATILE = &H1

Dim RootHKey As HKeys
Dim SubDir As String
Dim hKey As Long
Private Function OpenRegistry(ByVal RtHKey As HKeys, ByVal SbDr As String) As Integer
    
    On Error GoTo OpenReg
    
    Dim ReturnVal As Integer

    If RtHKey = 0 Then
        OpenRegistry = False
        Exit Function
    End If
    RootHKey = RtHKey
    SubDir = SbDr
    ReturnVal = RegOpenKeyEx(RootHKey, SubDir, 0&, KEY_READ_WRITE, hKey)
    If ReturnVal <> 0 Then
        OpenRegistry = False
        Exit Function
    End If
    OpenRegistry = True
    Exit Function

OpenReg:
    OpenRegistry = False
End Function
Private Function CloseRegistry() As Boolean
    
    On Error Resume Next

    If RegCloseKey(hKey) <> 0 Then
        CloseRegistry = False
        Exit Function
    End If
    CloseRegistry = True

End Function
Private Sub Class_Initialize()
    
    RootHKey = &H0
    hKey = 0

End Sub
Private Sub Class_Terminate()
    
    On Error Resume Next

    If RegCloseKey(hKey) <> 0 Then
        Exit Sub
    End If

End Sub
Public Function ISettings_SetKey(ByVal sSection As String, ByVal sKey As String, ByVal vntValue As Variant)

    If OpenRegistry(HKEY_CURRENT_USER, "Software\core\" & sSection) Then

        RegSetValueEx hKey, sKey, 0&, REG_SZ, vntValue & Chr(0), Len(vntValue & Chr(0))
        CloseRegistry
    
    End If

End Function
Public Function ISettings_GetKey(ByVal sSection As String, ByVal sKey As String) As String

    Dim textline As String
    Dim length As Long
    Dim RtnVal As Long
    Dim value_Type As lDataType
    
    If OpenRegistry(HKEY_CURRENT_USER, "Software\core\" & sSection) Then
        If RegQueryValueEx(hKey, sKey, 0&, value_Type, ByVal 0&, length) = 0 Then
            textline = Space$(length)
            RegQueryValueEx hKey, sKey, 0&, value_Type, ByVal textline, length
            textline = Left$(textline, length - 1)
            ISettings_GetKey = textline
        End If
        CloseRegistry
    End If

End Function
Public Sub ISettings_DelKey(ByVal sSection As String, vntKey As String)

    If OpenRegistry(HKEY_CURRENT_USER, "Software\core\" & sSection) Then
    
        RegDeleteValue hKey, vntKey
        CloseRegistry
    
    End If

End Sub
Public Function ISettings_GetSections() As String()
    
    Dim sections() As String
    Dim textline As String
    
    ReDim sections(0)
    If OpenRegistry(HKEY_CURRENT_USER, "Software\core") Then
        Do
            textline = Space$(256)
            If RegEnumKey(hKey, UBound(sections), textline, 256) <> 0 Then
                Exit Do
            End If
            textline = Left$(textline, InStr(textline, Chr$(0)) - 1)
            ReDim Preserve sections(UBound(sections) + 1)
            sections(UBound(sections)) = textline
        Loop
        CloseRegistry
    End If
    ISettings_GetSections = sections

End Function
Public Sub ISettings_CreateSection(ByVal sNewDirName As String)
    
    Dim hNewKey As Long
    Dim lpdwDisposition As Long
    Dim lpSecurityAttributes As SECURITY_ATTRIBUTES

    If OpenRegistry(HKEY_CURRENT_USER, "Software\core") Then

        RegCreateKeyEx hKey, sNewDirName, 0&, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lpSecurityAttributes, hNewKey, lpdwDisposition
        CloseRegistry
    
    End If

End Sub
Public Sub ISettings_DelSection(ByVal sKeyName As String)
    

    If OpenRegistry(HKEY_CURRENT_USER, "Software\core") Then

        RegDeleteKey hKey, sKeyName
        CloseRegistry
    
    End If

End Sub
